<?php

namespace platy\etsy\orders;

class EtsyOrder extends \WC_Order{

    function __construct($id = 0){
        parent::__construct($id);
        
    }

    function get_etsy_order_item($transaction_id){
        $items = $this->get_items();
        foreach($items as $item){
            if(wc_get_order_item_meta($item->get_id(), "_etsy_transaction_id", true) == $transaction_id){
                if($item->get_type() == 'line_item'){
                    return $item;
                }
            }
            
        }
        throw new NoSuchEtsyItemException('line_item', $transaction_id);
    }

    public function get_etsy_order_tax_item($tax_name){
        $items = $this->get_items('tax');
        foreach($items as $item){
            if($item->get_name() == $tax_name) {
                return $item;
            }
        }
        throw new NoSuchEtsyItemException('tax', "");
    }

    public function get_etsy_order_shipping_item($receipt_shipping_id){
        $items = $this->get_items('shipping');
        foreach($items as $item){
            if(wc_get_order_item_meta($item->get_id(), "etsy_receipt_shipping_id", true) == $receipt_shipping_id){
                return $item;
            }
        }
        throw new NoSuchEtsyItemException('shipping', "");
    }

    public function get_order_number(){
        $receit_id = get_post_meta($this->get_id(), "etsy_receipt_id", true);
        return empty($receit_id) ? $this->get_id() : $receit_id;
    }

}